<script setup lang="ts">
import _ from 'lodash'
import { storeToRefs } from 'pinia'
import { useQAStore } from '~~/store/qa'

const { full } = defineProps<{ full: boolean }>()
const QA = useQAStore()
const { availableQA } = storeToRefs(QA)
const scroll = ref<HTMLElement | null>(null)

const notifyEvent = inject('notifyEvent') as any[]
watch(
  () => availableQA.value.length,
  () => {
    if (!_.isNull(availableQA.value) && !_.isEmpty(availableQA.value)) {
      notifyEvent.push({
        tab: 'question',
        value: 1,
      })
    }
  },
)

// scroll
const scrollBottom = () => {
  setTimeout(() => {
    if (scroll.value)
      scroll.value.scrollTop = scroll.value.scrollHeight
  })
}
watch(
  () => _.size(QA.data),
  scrollBottom,
)
onMounted(() => {
  scrollBottom()
})
</script>

<template>
  <div class="relative">
    <div v-if="_.size(availableQA) > 0" ref="scroll" class="overflow-auto scrollBar absolute h-full w-full top-0">
      <MQuestionDetail v-for="(Qa) in availableQA" :id="Qa.id" :key="Qa.id" :full="full" :data="Qa" />
    </div>
    <div v-else class="absolute w-full h-full top-0 left-0 px-5 flex items-center justify-center text-center">
      <p v-if="full">
        配信に関する質問が送信されます。<br>
        質問が来た場合、質問に対して返信、或いは、口頭で回答するを選択し、配信中に回答をお願いします。<br>
        <span class="block h-5" />
        ※送信された質問は、他の会員には表示されません。<br>
        ※内容に応じて配信中に返信機能で回答するか、口頭で回答するかご注意ください。<br>
      </p>
      <p v-else>
        企業へ個別に質問が行えます。<br>
        <span class="block h-5" />
        ※送信した質問は、他の会員には表示されません。<br>
        ※企業から回答がない場合もありますので、ご了承ください。<br>
      </p>
    </div>
  </div>
</template>

<style scoped></style>
